<?php
/**
 * Jamroom 5 Back Time module
 *
 * copyright 2003 - 2016
 * by b360
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *

// make sure we are not being called directly
defined('APP_DIR') or exit();

 * meta
 */
function myBackTime_meta()
{
    $_tmp = array(
        'name'        => 'Back Time',
        'url'         => 'back_time',
        'version'     => '1.0.0',
        'developer'   => 'B360, &copy;' . strftime('%Y'),
        'description' => 'Counts back system time',
        'category'    => 'tools',
        'requires'    => 'myBackTime',
        'license'     => 'mpl'
    );
    return $_tmp;
}

/**
 * init
 */
function myBackTime_init()
{
    return true;
}

function smarty_function_elapsed_time ($params, &$smarty)
{
    extract($params);
    if (empty($timestamp))
    {
        return '';
    }
    if (empty($names))
    {
        $names = "day, hour, minute, a few seconds";
    }

    $n = explode (",",$names);
    if (count($n) < 4)
    {
        $n = array ("day", "hour", "minute", "a few seconds");
    }

    $difference = time() - intval($timestamp);

    $days = floor($difference / (60 * 60 * 24));
    $hours = floor($difference / (60 * 60));
    $minutes = floor($difference / 60);

    $s = "";
    $val = 0;
    if ($minutes > 0)
    {
        $val = $minutes;
        $s = $n[2];
        if ($hours > 0)
        {
            $val = $hours;
            $s = $n[1];
            if ($days > 0)
            {
                $val = $days;
                $s = $n[0];
                if ($days > 30)
                {
                    $val = "more than a month";
                    $s = $n[0];
                }
            }
        }
    }
    else
    {
        return $n[3];
    }

    $rest = $val % 10;
    if ($s == $n[0])
    {
        $s = "day";
        if ($rest > 1) { $s .= "s"; }
    }

    elseif ($s == $n[1])
    {
        $s = "hour";
        if ($rest > 1) { $s .= "s"; }
    }

    elseif ($s == $n[2])
    {
        $s = "minute";
        if ($rest > 1) { $s .= "s"; }
    }

    if (!empty($assign))
    {
        $smarty->assign($assign, $difference);
    }

    return "{$val} {$s} ago";

    return true;
}

